Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::Vector3 Class Reference

Standard 3-dimensional vector. More...

`#include <OgreVector3.h>`

List of all members.

## Public Member Functions
| Vector3 ()
| Vector3 (const Real fX, const Real fY, const Real fZ)
| Vector3 (const Real afCoordinate[3])
| Vector3 (const int afCoordinate[3])
| Vector3 (Real *const r)
| Vector3 (const Real scaler)
| Vector3 (const Vector3 &rkVector)
Real | operator[] (const size_t i) const
Real & | operator[] (const size_t i)
Real * | ptr ()
| Pointer accessor for direct copying.
const Real * | ptr () const
| Pointer accessor for direct copying.
Vector3 & | operator= (const Vector3 &rkVector)
| Assigns the value of the other vector.
Vector3 & | operator= (const Real fScaler)
bool | operator== (const Vector3 &rkVector) const
bool | operator!= (const Vector3 &rkVector) const
Vector3 | operator+ (const Vector3 &rkVector) const
Vector3 | operator- (const Vector3 &rkVector) const
Vector3 | operator * (const Real fScalar) const
Vector3 | operator * (const Vector3 &rhs) const
Vector3 | operator/ (const Real fScalar) const
Vector3 | operator/ (const Vector3 &rhs) const
const Vector3 & | operator+ () const
Vector3 | operator- () const
Vector3 & | operator+= (const Vector3 &rkVector)
Vector3 & | operator+= (const Real fScalar)
Vector3 & | operator-= (const Vector3 &rkVector)
Vector3 & | operator-= (const Real fScalar)
Vector3 & | operator *= (const Real fScalar)
Vector3 & | operator *= (const Vector3 &rkVector)
Vector3 & | operator/= (const Real fScalar)
Vector3 & | operator/= (const Vector3 &rkVector)
Real | length () const
| Returns the length (magnitude) of the vector.
Real | squaredLength () const
| Returns the square of the length(magnitude) of the vector.
Real | distance (const Vector3 &rhs) const
| Returns the distance to another vector.
Real | squaredDistance (const Vector3 &rhs) const
| Returns the square of the distance to another vector.
Real | dotProduct (const Vector3 &vec) const
| Calculates the dot (scalar) product of this vector with another.
Real | absDotProduct (const Vector3 &vec) const
| Calculates the absolute dot (scalar) product of this vector with another.
Real | normalise ()
| Normalises the vector.
Vector3 | crossProduct (const Vector3 &rkVector) const
| Calculates the cross-product of 2 vectors, i.e.
Vector3 | midPoint (const Vector3 &vec) const
| Returns a vector at a point half way between this and the passed in vector.
bool | operator< (const Vector3 &rhs) const
| Returns true if the vector's scalar components are all greater that the ones of the vector it is compared against.
bool | operator> (const Vector3 &rhs) const
| Returns true if the vector's scalar components are all smaller that the ones of the vector it is compared against.
void | makeFloor (const Vector3 &cmp)
| Sets this vector's components to the minimum of its own and the ones of the passed in vector.
void | makeCeil (const Vector3 &cmp)
| Sets this vector's components to the maximum of its own and the ones of the passed in vector.
Vector3 | perpendicular (void) const
| Generates a vector perpendicular to this vector (eg an 'up' vector).
Vector3 | randomDeviant (const Radian &angle, const Vector3 &up=Vector3::ZERO) const
| Generates a new random vector which deviates from this vector by a given angle in a random direction.
Quaternion | getRotationTo (const Vector3 &dest, const Vector3 &fallbackAxis=Vector3::ZERO) const
| Gets the shortest arc quaternion to rotate this vector to the destination vector.
bool | isZeroLength (void) const
| Returns true if this vector is zero length.
Vector3 | normalisedCopy (void) const
| As normalise, except that this vector is unaffected and the normalised vector is returned as a copy.
Vector3 | reflect (const Vector3 &normal) const
| Calculates a reflection vector to the plane with the given normal .
bool | positionEquals (const Vector3 &rhs, Real tolerance=1e-03) const
| Returns whether this vector is within a positional tolerance of another vector.
bool | positionCloses (const Vector3 &rhs, Real tolerance=1e-03f) const
| Returns whether this vector is within a positional tolerance of another vector, also take scale of the vectors into account.
bool | directionEquals (const Vector3 &rhs, const Radian &tolerance) const
| Returns whether this vector is within a directional tolerance of another vector.
## Public Attributes
Real | x
Real | y
Real | z
## Static Public Attributes
static const Vector3 | ZERO
static const Vector3 | UNIT_X
static const Vector3 | UNIT_Y
static const Vector3 | UNIT_Z
static const Vector3 | NEGATIVE_UNIT_X
static const Vector3 | NEGATIVE_UNIT_Y
static const Vector3 | NEGATIVE_UNIT_Z
static const Vector3 | UNIT_SCALE
## Friends
Vector3 | operator * (const Real fScalar, const Vector3 &rkVector)
Vector3 | operator/ (const Real fScalar, const Vector3 &rkVector)
Vector3 | operator+ (const Vector3 &lhs, const Real rhs)
Vector3 | operator+ (const Real lhs, const Vector3 &rhs)
Vector3 | operator- (const Vector3 &lhs, const Real rhs)
Vector3 | operator- (const Real lhs, const Vector3 &rhs)
_OgreExport friend std::ostream & | operator<< (std::ostream &o, const Vector3 &v)
| Function for writing to a stream.

## Detailed Description

Standard 3-dimensional vector.

Remarks:
  A direction in 3D space represented as distances along the 3 orthoganal axes (x, y, z). Note that positions, directions and scaling factors can be represented by a vector, depending on how you interpret the values.

Definition at line 46 of file OgreVector3.h.

## Constructor & Destructor Documentation

Ogre::Vector3::Vector3 | ( |  | ) |

| Definition at line 52 of file OgreVector3.h.

Ogre::Vector3::Vector3 | ( | const Real | fX,
|  | const Real | fY,
|  | const Real | fZ
| ) |

| Definition at line 56 of file OgreVector3.h.

Ogre::Vector3::Vector3 | ( | const Real | afCoordinate[3] | ) | `[explicit]`

| Definition at line 61 of file OgreVector3.h.

Ogre::Vector3::Vector3 | ( | const int | afCoordinate[3] | ) | `[explicit]`

| Definition at line 68 of file OgreVector3.h.

Ogre::Vector3::Vector3 | ( | Real *const | r | ) | `[explicit]`

| Definition at line 75 of file OgreVector3.h.

Ogre::Vector3::Vector3 | ( | const Real | scaler | ) | `[explicit]`

| Definition at line 80 of file OgreVector3.h.

Ogre::Vector3::Vector3 | ( | const Vector3 & | rkVector | ) |

| Definition at line 88 of file OgreVector3.h.

## Member Function Documentation

Real Ogre::Vector3::absDotProduct | ( | const Vector3 & | vec | ) | const

  | Calculates the absolute dot (scalar) product of this vector with another. Remarks: This function work similar dotProduct, except it use absolute value of each component of the vector to computing. Parameters:
  | vec | Vector with which to calculate the absolute dot product (together with this one).
Returns: A Real representing the absolute dot product value. Definition at line 419 of file OgreVector3.h.

Vector3 Ogre::Vector3::crossProduct | ( | const Vector3 & | rkVector | ) | const

  | Calculates the cross-product of 2 vectors, i.e. the vector that lies perpendicular to them both. Remarks: The cross-product is normally used to calculate the normal vector of a plane, by calculating the cross-product of 2 non-equivalent vectors which lie on the plane (e.g. 2 edges of a triangle). Parameters:
  | vec | Vector which, together with this one, will be used to calculate the cross-product.
Returns: A vector which is the result of the cross-product. This vector will NOT be normalised, to maximise efficiency call Vector3::normalise on the result if you wish this to be done. As for which side the resultant vector will be on, the returned vector will be on the side from which the arc from 'this' to rkVector is anticlockwise, e.g. UNIT_Y.crossProduct(UNIT_Z) = UNIT_X, whilst UNIT_Z.crossProduct(UNIT_Y) = -UNIT_X. This is because OGRE uses a right-handed coordinate system. For a clearer explanation, look a the left and the bottom edges of your monitor's screen. Assume that the first vector is the left edge and the second vector is the bottom edge, both of them starting from the lower-left corner of the screen. The resulting vector is going to be perpendicular to both of them and will go inside the screen, towards the cathode tube (assuming you're using a CRT monitor, of course). Definition at line 477 of file OgreVector3.h. Referenced by getRotationTo().

bool Ogre::Vector3::directionEquals | ( | const Vector3 & | rhs,
|  | const Radian & | tolerance
| ) | const

  | Returns whether this vector is within a directional tolerance of another vector. Parameters:
  | rhs | The vector to compare with
  | tolerance | The maximum angle by which the vectors may vary and still be considered equal
Note: Both vectors should be normalised. Definition at line 738 of file OgreVector3.h. References Ogre::Radian::valueRadians().

Real Ogre::Vector3::distance | ( | const Vector3 & | rhs | ) | const

| Returns the distance to another vector. Warning: This operation requires a square root and is expensive in terms of CPU operations. If you don't need to know the exact distance (e.g. for just comparing distances) use squaredDistance() instead. Definition at line 370 of file OgreVector3.h.

Real Ogre::Vector3::dotProduct | ( | const Vector3 & | vec | ) | const

  | Calculates the dot (scalar) product of this vector with another. Remarks: The dot product can be used to calculate the angle between 2 vectors. If both are unit vectors, the dot product is the cosine of the angle; otherwise the dot product must be divided by the product of the lengths of both vectors to get the cosine of the angle. This result can further be used to calculate the distance of a point from a plane. Parameters:
  | vec | Vector with which to calculate the dot product (together with this one).
Returns: A float representing the dot product value. Definition at line 404 of file OgreVector3.h. Referenced by getRotationTo().

Quaternion Ogre::Vector3::getRotationTo | ( | const Vector3 & | dest,
|  | const Vector3 & | fallbackAxis = `Vector3::ZERO`
| ) | const

| Gets the shortest arc quaternion to rotate this vector to the destination vector. Remarks: If you call this with a dest vector that is close to the inverse of this vector, we will rotate 180 degrees around the 'fallbackAxis' (if specified, or a generated axis if not) since in this case ANY axis of rotation is valid. Definition at line 630 of file OgreVector3.h. References crossProduct(), dotProduct(), Ogre::Quaternion::FromAngleAxis(), isZeroLength(), Ogre::Quaternion::normalise(), normalise(), Ogre::Quaternion::w, x, Ogre::Quaternion::x, y, Ogre::Quaternion::y, z, and Ogre::Quaternion::z.

bool Ogre::Vector3::isZeroLength | ( | void |  | ) | const

| Returns true if this vector is zero length. Definition at line 681 of file OgreVector3.h. Referenced by getRotationTo().

Real Ogre::Vector3::length | ( |  | ) | const

| Returns the length (magnitude) of the vector. Warning: This operation requires a square root and is expensive in terms of CPU operations. If you don't need to know the exact length (e.g. for just comparing lengths) use squaredLength() instead. Definition at line 343 of file OgreVector3.h.

void Ogre::Vector3::makeCeil | ( | const Vector3 & | cmp | ) |

| Sets this vector's components to the maximum of its own and the ones of the passed in vector. Remarks: 'Maximum' in this case means the combination of the highest value of x, y and z from both vectors. Highest is taken just numerically, not magnitude, so 1 > -3. Definition at line 537 of file OgreVector3.h. Referenced by Ogre::AxisAlignedBox::intersection(), and Ogre::AxisAlignedBox::merge().

void Ogre::Vector3::makeFloor | ( | const Vector3 & | cmp | ) |

| Sets this vector's components to the minimum of its own and the ones of the passed in vector. Remarks: 'Minimum' in this case means the combination of the lowest value of x, y and z from both vectors. Lowest is taken just numerically, not magnitude, so -1 < 0. Definition at line 523 of file OgreVector3.h. Referenced by Ogre::AxisAlignedBox::intersection(), and Ogre::AxisAlignedBox::merge().

Vector3 Ogre::Vector3::midPoint | ( | const Vector3 & | vec | ) | const

| Returns a vector at a point half way between this and the passed in vector. Definition at line 488 of file OgreVector3.h.

Real Ogre::Vector3::normalise | ( |  | ) |

| Normalises the vector. Remarks: This method normalises the vector such that it's length / magnitude is 1. The result is called a unit vector. Note: This function will not crash for zero-sized vectors, but there will be no changes made to their components. Returns: The previous length of the vector. Definition at line 433 of file OgreVector3.h. Referenced by getRotationTo(), normalisedCopy(), Ogre::Matrix4::operator *(), and perpendicular().

Vector3 Ogre::Vector3::normalisedCopy | ( | void |  | ) | const

| As normalise, except that this vector is unaffected and the normalised vector is returned as a copy. Definition at line 690 of file OgreVector3.h. References normalise().

Vector3 Ogre::Vector3::operator * | ( | const Vector3 & | rhs | ) | const

| Definition at line 174 of file OgreVector3.h.

Vector3 Ogre::Vector3::operator * | ( | const Real | fScalar | ) | const

| Definition at line 166 of file OgreVector3.h.

Vector3& Ogre::Vector3::operator *= | ( | const Vector3 & | rkVector | ) |

| Definition at line 304 of file OgreVector3.h.

Vector3& Ogre::Vector3::operator *= | ( | const Real | fScalar | ) |

| Definition at line 296 of file OgreVector3.h.

bool Ogre::Vector3::operator!= | ( | const Vector3 & | rkVector | ) | const

| Definition at line 144 of file OgreVector3.h.

const Vector3& Ogre::Vector3::operator+ | ( |  | ) | const

| Definition at line 202 of file OgreVector3.h.

Vector3 Ogre::Vector3::operator+ | ( | const Vector3 & | rkVector | ) | const

| Definition at line 150 of file OgreVector3.h.

Vector3& Ogre::Vector3::operator+= | ( | const Real | fScalar | ) |

| Definition at line 271 of file OgreVector3.h.

Vector3& Ogre::Vector3::operator+= | ( | const Vector3 & | rkVector | ) |

| Definition at line 262 of file OgreVector3.h.

Vector3 Ogre::Vector3::operator- | ( |  | ) | const

| Definition at line 207 of file OgreVector3.h.

Vector3 Ogre::Vector3::operator- | ( | const Vector3 & | rkVector | ) | const

| Definition at line 158 of file OgreVector3.h.

Vector3& Ogre::Vector3::operator-= | ( | const Real | fScalar | ) |

| Definition at line 288 of file OgreVector3.h.

Vector3& Ogre::Vector3::operator-= | ( | const Vector3 & | rkVector | ) |

| Definition at line 279 of file OgreVector3.h.

Vector3 Ogre::Vector3::operator/ | ( | const Vector3 & | rhs | ) | const

| Definition at line 194 of file OgreVector3.h.

Vector3 Ogre::Vector3::operator/ | ( | const Real | fScalar | ) | const

| Definition at line 182 of file OgreVector3.h.

Vector3& Ogre::Vector3::operator/= | ( | const Vector3 & | rkVector | ) |

| Definition at line 326 of file OgreVector3.h.

Vector3& Ogre::Vector3::operator/= | ( | const Real | fScalar | ) |

| Definition at line 313 of file OgreVector3.h.

bool Ogre::Vector3::operator< | ( | const Vector3 & | rhs | ) | const

| Returns true if the vector's scalar components are all greater that the ones of the vector it is compared against. Definition at line 499 of file OgreVector3.h.

Vector3& Ogre::Vector3::operator= | ( | const Real | fScaler | ) |

| Definition at line 130 of file OgreVector3.h.

Vector3& Ogre::Vector3::operator= | ( | const Vector3 & | rkVector | ) |

  | Assigns the value of the other vector. Parameters:
  | rkVector | The other vector
Definition at line 121 of file OgreVector3.h.

bool Ogre::Vector3::operator== | ( | const Vector3 & | rkVector | ) | const

| Definition at line 139 of file OgreVector3.h.

bool Ogre::Vector3::operator> | ( | const Vector3 & | rhs | ) | const

| Returns true if the vector's scalar components are all smaller that the ones of the vector it is compared against. Definition at line 509 of file OgreVector3.h.

Real& Ogre::Vector3::operator[] | ( | const size_t | i | ) |

| Definition at line 100 of file OgreVector3.h.

Real Ogre::Vector3::operator[] | ( | const size_t | i | ) | const

| Definition at line 93 of file OgreVector3.h.

Vector3 Ogre::Vector3::perpendicular | ( | void |  | ) | const

| Generates a vector perpendicular to this vector (eg an 'up' vector). Remarks: This method will return a vector which is perpendicular to this vector. There are an infinite number of possibilities but this method will guarantee to generate one of them. If you need more control you should use the Quaternion class. Definition at line 551 of file OgreVector3.h. References normalise(), and squaredLength().

bool Ogre::Vector3::positionCloses | ( | const Vector3 & | rhs,
|  | Real | tolerance = `1e-03f`
| ) | const

  | Returns whether this vector is within a positional tolerance of another vector, also take scale of the vectors into account. Parameters:
  | rhs | The vector to compare with
  | tolerance | The amount (related to the scale of vectors) that distance of the vector may vary by and still be considered close
Definition at line 725 of file OgreVector3.h.

bool Ogre::Vector3::positionEquals | ( | const Vector3 & | rhs,
|  | Real | tolerance = `1e-03`
| ) | const

  | Returns whether this vector is within a positional tolerance of another vector. Parameters:
  | rhs | The vector to compare with
  | tolerance | The amount that each element of the vector may vary by and still be considered equal
Definition at line 711 of file OgreVector3.h.

const Real* Ogre::Vector3::ptr | ( |  | ) | const

| Pointer accessor for direct copying. Definition at line 112 of file OgreVector3.h.

Real* Ogre::Vector3::ptr | ( |  | ) |

| Pointer accessor for direct copying. Definition at line 107 of file OgreVector3.h.

Vector3 Ogre::Vector3::randomDeviant | ( | const Radian & | angle,
|  | const Vector3 & | up = `Vector3::ZERO`
| ) | const

  | Generates a new random vector which deviates from this vector by a given angle in a random direction. Remarks: This method assumes that the random number generator has already been seeded appropriately. Parameters:
  | angle | The angle at which to deviate
  | up | Any vector perpendicular to this one (which could generated by cross-product of this vector and any other non-colinear vector). If you choose not to provide this the function will derive one on it's own, however if you provide one yourself the function will be faster (this allows you to reuse up vectors if you call this method more than once)
Returns: A random vector which deviates from this vector by angle. This vector will not be normalised, normalise it if you wish afterwards. Definition at line 588 of file OgreVector3.h. References Ogre::Quaternion::FromAngleAxis().

Vector3 Ogre::Vector3::reflect | ( | const Vector3 & | normal | ) | const

| Calculates a reflection vector to the plane with the given normal . Remarks: NB assumes 'this' is pointing AWAY FROM the plane, invert if it is not. Definition at line 700 of file OgreVector3.h.

Real Ogre::Vector3::squaredDistance | ( | const Vector3 & | rhs | ) | const

| Returns the square of the distance to another vector. Remarks: This method is for efficiency - calculating the actual distance to another vector requires a square root, which is expensive in terms of the operations required. This method returns the square of the distance to another vector, i.e. the same as the distance but before the square root is taken. Use this if you want to find the longest / shortest distance without incurring the square root. Definition at line 385 of file OgreVector3.h.

Real Ogre::Vector3::squaredLength | ( |  | ) | const

| Returns the square of the length(magnitude) of the vector. Remarks: This method is for efficiency - calculating the actual length of a vector requires a square root, which is expensive in terms of the operations required. This method returns the square of the length of the vector, i.e. the same as the length but before the square root is taken. Use this if you want to find the longest / shortest vector without incurring the square root. Definition at line 358 of file OgreVector3.h. Referenced by perpendicular().

## Friends And Related Function Documentation

Vector3 operator * | ( | const Real | fScalar,
|  | const Vector3 & | rkVector
| ) | `[friend]`

| Definition at line 213 of file OgreVector3.h.

Vector3 operator+ | ( | const Real | lhs,
|  | const Vector3 & | rhs
| ) | `[friend]`

| Definition at line 237 of file OgreVector3.h.

Vector3 operator+ | ( | const Vector3 & | lhs,
|  | const Real | rhs
| ) | `[friend]`

| Definition at line 229 of file OgreVector3.h.

Vector3 operator- | ( | const Real | lhs,
|  | const Vector3 & | rhs
| ) | `[friend]`

| Definition at line 253 of file OgreVector3.h.

Vector3 operator- | ( | const Vector3 & | lhs,
|  | const Real | rhs
| ) | `[friend]`

| Definition at line 245 of file OgreVector3.h.

Vector3 operator/ | ( | const Real | fScalar,
|  | const Vector3 & | rkVector
| ) | `[friend]`

| Definition at line 221 of file OgreVector3.h.

_OgreExport friend std::ostream& operator<< | ( | std::ostream & | o,
|  | const Vector3 & | v
| ) | `[friend]`

| Function for writing to a stream. Definition at line 761 of file OgreVector3.h.

## Member Data Documentation

const Vector3 Ogre::Vector3::NEGATIVE_UNIT_X`[static]`

| Definition at line 753 of file OgreVector3.h.

const Vector3 Ogre::Vector3::NEGATIVE_UNIT_Y`[static]`

| Definition at line 754 of file OgreVector3.h.

const Vector3 Ogre::Vector3::NEGATIVE_UNIT_Z`[static]`

| Definition at line 755 of file OgreVector3.h.

const Vector3 Ogre::Vector3::UNIT_SCALE`[static]`

| Definition at line 756 of file OgreVector3.h.

const Vector3 Ogre::Vector3::UNIT_X`[static]`

| Definition at line 750 of file OgreVector3.h.

const Vector3 Ogre::Vector3::UNIT_Y`[static]`

| Definition at line 751 of file OgreVector3.h.

const Vector3 Ogre::Vector3::UNIT_Z`[static]`

| Definition at line 752 of file OgreVector3.h.

Real Ogre::Vector3::x

| Definition at line 49 of file OgreVector3.h. Referenced by Ogre::AxisAlignedBox::contains(), getRotationTo(), Ogre::AxisAlignedBox::intersection(), Ogre::Matrix4::operator *(), Ogre::AxisAlignedBox::transform(), Ogre::AxisAlignedBox::transformAffine(), and Ogre::AxisAlignedBox::volume().

Real Ogre::Vector3::y

| Definition at line 49 of file OgreVector3.h. Referenced by Ogre::AxisAlignedBox::contains(), getRotationTo(), Ogre::AxisAlignedBox::intersection(), Ogre::Matrix4::operator *(), Ogre::AxisAlignedBox::transform(), Ogre::AxisAlignedBox::transformAffine(), and Ogre::AxisAlignedBox::volume().

Real Ogre::Vector3::z

| Definition at line 49 of file OgreVector3.h. Referenced by Ogre::AxisAlignedBox::contains(), getRotationTo(), Ogre::AxisAlignedBox::intersection(), Ogre::Matrix4::operator *(), Ogre::AxisAlignedBox::transform(), Ogre::AxisAlignedBox::transformAffine(), and Ogre::AxisAlignedBox::volume().

const Vector3 Ogre::Vector3::ZERO`[static]`

| Definition at line 749 of file OgreVector3.h.

The documentation for this class was generated from the following file:

- OgreVector3.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:49:41 2008